      subroutine corr(ffta1, ffta2, hklx, hkly, lann, hann, value)
       
C     Compute the correaltion coefficiency of two 2D DFT in the range of
C     radius from lann to hann and return value

      implicit none
      integer, intent(in) :: hklx, hkly
      real, intent(in)    :: ffta1(0:hklx,-hkly:hkly)
      real, intent(in)    :: ffta2(0:hklx,-hkly:hkly)
      real, intent(in)    :: lann, hann
      real, intent(out)   :: value
      
      double precision a1sum, a2sum, a1sqsum, a2sqsum, a1a2sum
      integer icount, x, y
      real    radius, lsq, hsq, ysq
      
      a1sum = 0.0
      a2sum = 0.0
      a1sqsum = 0.0
      a2sqsum = 0.0
      a1a2sum = 0.0
      icount = 0
      lsq = lann**2
      hsq = hann**2
      value = 0.
      
      if (lann >= hann) return

      do y = -hkly, hkly
         ysq = y*y
         do x = 0, hklx
            radius = x*x + ysq
            if (radius <= hsq .and. radius >= lsq) then 
               a1sum   = a1sum + ffta1(x,y)
               a2sum   = a2sum + ffta2(x,y)
               a1sqsum = a1sqsum + ffta1(x,y)*ffta1(x,y)
               a2sqsum = a2sqsum + ffta2(x,y)*ffta2(x,y)
               a1a2sum = a1a2sum + ffta1(x,y)*ffta2(x,y)
               icount = icount + 1
            endif
         enddo
      enddo

      if (icount > 0) then
         value = abs(a1a2sum - a1sum*a2sum / icount )
     +        / sqrt( abs( a1sqsum - a1sum**2 /icount))
     +        / sqrt( abs( a2sqsum - a2sum**2 /icount))
      endif
      
      return
      end subroutine corr
      
